package WebFlow;

import WebFlow.event.*;
import java.util.*;
import java.lang.*;
import java.lang.reflect.*;
import org.omg.CORBA.InterfaceDefPackage.*;
  
public class FactoryImpl  extends _moduleFactoryImplBase
//implements Runnable

{
  public org.omg.CORBA.ORB orb;
  public org.omg.CORBA.BOA boa;
  String WFSname_;
  WebFlowContext WebFlowServer;
  org.omg.CORBA.Object  ConfigObj;
  configReader ConfigServer;
  moduleFactory otherMFImpl,thirdMFImpl;
  
  private moduleFactory  RedMFImpl,BlackMFImpl,WhiteMFImpl,GreenMFImpl;
  private moduleFactory  MFImpl;

  static final int RED=1;
  static final int BLACK=2;
  static final int WHITE=3;
  static final int GREEN=4;
  int myColor; //RED or BLACK or WHITE or GREEN

    public FactoryImpl(String WebFlowIOR, String ConfigIOR)
  {

    String [] args =  {""};
        
    orb    = org.omg.CORBA.ORB.init(args, new java.util.Properties());
    boa    = ((com.ooc.CORBA.ORB)orb).BOA_init(args, new java.util.Properties());
   
    //get nameServer object
    org.omg.CORBA.Object ConfigObj;
  	ConfigObj  = orb.string_to_object(ConfigIOR);
    ConfigServer = configReaderHelper.narrow(ConfigObj);

    //Importtant Do not delete the following line
    //feed back the my ior to parenbt process
    System.out.println(orb.object_to_string(this));
    WebFlowServer = WebFlowContextHelper.narrow(orb.string_to_object(WebFlowIOR));  

    /*Thread thr = new Thread(this);
    thr.start();
    */
  }

 public FactoryImpl(String WebFlowIOR, String ConfigIOR,int myColor,
      org.omg.CORBA.ORB orb, org.omg.CORBA.BOA boa)
  {

    String [] args =  {""};

    this.orb = orb;
    this.boa = boa;
    this.myColor = myColor;
    //get nameServer object
    org.omg.CORBA.Object ConfigObj;
        ConfigObj  = orb.string_to_object(ConfigIOR);
    ConfigServer = configReaderHelper.narrow(ConfigObj);

    //Importtant Do not delete the following line
    //feed back the my ior to parenbt process
    System.out.println(orb.object_to_string(this));
    WebFlowServer = WebFlowContextHelper.narrow(orb.string_to_object(WebFlowIOR));  
    orb.connect(this);

    /*
    Thread thr = new Thread(this);
    thr.start();
    */
  }

  
  public FactoryImpl(String WebFlowIOR, String ConfigIOR, int myColor) 
  {
    this(WebFlowIOR, ConfigIOR);
    this.myColor = myColor;
  }
  
  public void dispose ()
{
  orb.disconnect(this);
}

public void deactivate()
{
  System.out.println("FactoryImpl(deactivate) Called...");
   try{
      boa.deactivate_impl(null);
    }catch(org.omg.CORBA.COMM_FAILURE ex){
        System.out.println("FactoryImpl(deactivate) Exc.:"+ex);
     } 
} 

   public   int getColor()
    {
	return myColor;
    }

  public void setOtherMFImpl (moduleFactory other, int color)
  {
	if (color == FactoryImpl.RED)
	  RedMFImpl = other;
	else if (color == FactoryImpl.BLACK)
	  BlackMFImpl = other;
  }

  
public  int  choseChildColor()
    {
      int child=0;
      
      /* RBWG : chose in cyclic manner. */
      if (myColor == FactoryImpl.RED)
	  child = FactoryImpl.BLACK;
      else if (myColor == FactoryImpl.BLACK)
	  child = FactoryImpl.WHITE;
      else if (myColor == FactoryImpl.WHITE)
	  child = FactoryImpl.GREEN;
      else if (myColor == FactoryImpl.GREEN)
	  child = FactoryImpl.RED;
      return child;
      
    }

 public  moduleFactory  prevChild()
    {
      moduleFactory child=null;
            
      /* RBWG : chose in cyclic manner. */
      if (myColor == FactoryImpl.RED)
	child = BlackMFImpl;
      else if (myColor == FactoryImpl.BLACK)
	child = RedMFImpl;
      
      return child;
    }

    

public  moduleFactory  choseChild()
    {
      moduleFactory child=null;
            
      /* RBWG : chose in cyclic manner. */
      if (myColor == FactoryImpl.RED)
	  child = BlackMFImpl;  
      else if (myColor == FactoryImpl.BLACK)
	  child = RedMFImpl;
      return child;
      
    }


public void run()
  {
    orb.connect(this);
    //
    // Run implementation
    //
    //if (boa != null)
    //  boa.impl_is_ready(null);
    System.out.println("ModuleFactory exited thread run method...");
        
  }

 public void run_old()
  {
    orb.connect(this);
    //
    // Run implementation
    //
    //boa.impl_is_ready(null);
    System.out.println("ModuleFactory exited thread run method...");
        
  }
  
  //instantiate a context
  public org.omg.CORBA.Object createRemoteContext(String BCName, 
						  String objectID)
	throws PropertyVetoException,NullPointerException
  {
    //changed
    WebFlowContextImpl cimpl; //org.omg.CORBA.Object cimpl;
    //System.out.println("FACTORY:Color:"+myColor+" creates :"+BCName+
    //	       " ID:"+objectID);

    int context_color=myColor;
    cimpl = new WebFlowContextImpl(ConfigServer,orb,BCName, this);
    //System.out.println("FACTORY:Color: after cimpl=");
    
    //set orb
    cimpl.getImpl().setOrb(orb);

    //add
    cimpl.getImpl().setObjectID(objectID);
    //System.out.println("FACTORY:Color: after cimpl.getImpll()=");

    orb.connect(cimpl);
    return cimpl;
  }
  
   //instantiate one proxy object for a context : this is proxy to a WebFlow Server
   public org.omg.CORBA.Object createProxy(String BCName, 
					   org.omg.CORBA.Object remoteObj)
  {
      System.out.println("FactoryImpl: createProxy:"+BCName);
      org.omg.CORBA.Object obj = new ProxyImpl(BCName, remoteObj, orb, this);
      System.out.println("FactoryImpl: createProxy:after new proxy()"+BCName);
      orb.connect(obj);
      return obj;
  }
  
   public org.omg.CORBA.Object addProxyChild(org.omg.CORBA.Object parent,
					     org.omg.CORBA.Object remoteObj)
  {
      System.out.println("addProxyChild: Entered");
      org.omg.CORBA.Object obj;
      obj = new ProxyImpl("PROXY_CHILD", remoteObj, orb, this,"CHILD");
      System.out.println("addProxyChild: created proxy:"+obj);

      //set local object as a peer of remote one
      BeanContextChild bcc = BeanContextChildHelper.narrow(remoteObj);
      System.out.println("FactoryImpl:addProxyChild: Set proxy:bcc:"+bcc+" to obj:"+obj);
      bcc.setMyProxy(obj);
      System.out.println("FactoryImpl:addProxyChild: Set proxy:");

      //get Object id
      String objectId = bcc.getObjectID();
      //System.out.println("addProxyChild: after get objectId:"+objectId);

      //connect it to object adapter
      orb.connect(obj);
      
      //add proxy to its parent
      WebFlowContext wfc = WebFlowContextHelper.narrow(parent);
      //System.out.println("addProxyChild: Set proxy:wcc:"+wfc);
      wfc.addModule(obj, objectId);
      //System.out.println("addProxyChild: Added proxy:");

      //return the created product,one actor
      return obj;
  }

   public org.omg.CORBA.Object addProxyContext(org.omg.CORBA.Object parent,
					       org.omg.CORBA.Object remoteObj)
  {
      org.omg.CORBA.Object obj;
   
      System.out.println("CreateProduct:starting");
      obj = new ProxyImpl("PROXY_CONTEXT", remoteObj, orb, this);
      System.out.println("CreateProduct: got remote obj:"+remoteObj+
			 "Color:"+myColor);

      //set local object as a peer of remote one
      BeanContextChild bcc = BeanContextChildHelper.narrow(remoteObj);
      bcc.setMyProxy(obj);
      System.out.println("addProxyContext:add me as a proxy");

      //get Object id
      String objectId = bcc.getObjectID();
      System.out.println("addProxyContext:after get objectId:"+objectId);

      //connect it to object adapter
      orb.connect(obj);
      

      //test
      bcc = BeanContextChildHelper.narrow(parent);
      String id = bcc.getObjectID();
      System.out.println("CreateProduct:ParentId:"+id);
      //etst

      //add proxy to its parent
      WebFlowContext wfc = WebFlowContextHelper.narrow(parent);
      wfc.addContext(obj,objectId);
      System.out.println("addProxyContext:add to its Container");

      //return the created product,one actor
      return obj;
  }

   
  /*
    //Find first XXXImplBase_tie class with the way:
    //1. Class[] cls = userModuleClass.getInterfaces()
    //2. cls[0] =  userModuleOperations
    //3. finally, find userModuleImplBase_tie
    //then do this new XXXImplBase_tie(obj) with reflection utility of java
    //e.g newInstance method of java.lang.Class 
    //Because user modules just implement the functionality but 
    //not extending from XXXImplBase IDL-generated class
    User modules are like:
    class userModule extends BeanContextChildSupport 
    implements userModuleOperations
    {
    public userModule(org.omg.CORBA.Object peer, String productName)
    {
    super(peer);
    .
    }
    }
  */   
  //instantiate a module
  //public org.omg.CORBA.Object createProduct(String productName)
  public org.omg.CORBA.Object createRemoteProduct(String productName,
						  String objectID)
  {  

    System.out.println("Factory:"+myColor+" color product:"+productName);
    

    String IRid;
    String implClassName=null;
    Class implClass = null, tieClass=null;
    Object implObj   = null;
	org.omg.CORBA.Object tieObj=null;
    Constructor[] constructors = null;
    String OpsInterface=null;
    int k;

    //extract product name from its full path of name
    //Here product name:c1/c2/..../c2/productName where ci is ith contect name
    productName = productName.substring(productName.lastIndexOf("/")+1);
    //System.out.println("createProduct entered configserver:"+ConfigServer);
    try{ 
        //find full name of XXXOperations interface from 
	//its impelemented interfaces
		implClassName = ConfigServer.getImplClass(productName);
		implClass     = Class.forName(implClassName); 
		Class []clss  = implClass.getInterfaces();
		for(k=0;k<clss.length;k++){
			if (clss[k].getName().indexOf("Operations") >=0 ){
			    OpsInterface = clss[k].getName();
				//System.out.println("I got XXXOperations interface:"+OpsInterface);
				break;
			}
		}
		if (k==clss.length)
			return null;
		
		//System.out.println("Factory:"+
		//     " makes new product with implClassname:"+
		//     implClassName+" server:"+productName+" opsInt:"+OpsInterface);

		//find full name of XXXImplBas_tie class from XXXOperations interface
		String tieClassName,packageName;
		int index    = OpsInterface.lastIndexOf(".");
		tieClassName = OpsInterface.substring(index+1);
		packageName  = OpsInterface.substring(0, index+1);
		tieClassName = tieClassName.substring(0,tieClassName.indexOf("Operations"));
		tieClassName = packageName+"_"+tieClassName+"ImplBase_tie";
		//System.out.println("Factory: result className:"+tieClassName);


		// _XXXImplBase_tie tieObj = new _XXXImplBase_tie(null) 
		// where XXX is found in above
		tieClass = Class.forName(tieClassName); 
		constructors = tieClass.getConstructors();
		Object []initArgs = {null};
		tieObj = (org.omg.CORBA.Object)constructors[0].newInstance(initArgs) ;
		//System.out.println("_XXXImplBase_tie tieObj=new _XXXImplBase_tie(null)");

		//implObj = new userModule(org.omg.CORBA.Object peer, String name);
		constructors = implClass.getConstructors();
		Object []initArgs_1 = {tieObj,productName};
		implObj = constructors[0].newInstance(initArgs_1) ;
		//System.out.println("implObj = new userModule()");

		//implObj.setOrb(orb);
		Class []parTypes = {Class.forName("org.omg.CORBA.ORB")};
		Method m	     = implClass.getMethod("setOrb", parTypes);
		Object []args_1  = {orb};
		m.invoke(implObj, args_1);
	        System.out.println("implObj.setOrb(orb)");

		//tieObj._delegate(implObj);
		Class []parameterTypes = {Class.forName(OpsInterface)};
		m	                   = tieClass.getMethod("_delegate", parameterTypes);
		Object []args          = {implObj};
		m.invoke(tieObj, args);
		System.out.println("tieObj._delegate(implObj)");
		
		//get IR idl name
		m          = tieClass.getMethod("_ids", null);
		String []s = (String[])(m.invoke(tieObj, null));
		System.out.println("After get Invoke");
		
    }catch(ClassNotFoundException e){
      System.out.println("ClassNotFoundException : "+implClassName+": "+e);
    }
	catch (IllegalAccessException e){
      System.out.println("MF:IllegalAccessException :"+implClassName+": "+e);
       e.printStackTrace();
    } 
	catch(InstantiationException e){
      System.out.println("MF:InstantiationException :"+implClassName+": "+e);
       e.printStackTrace();
    } 
	catch(InvocationTargetException e){
      System.out.println("MF:InvocationTargetException:"+implClassName+": "+e);
      e.printStackTrace();
    }
    catch(java.lang.IllegalArgumentException e){
      System.out.println("MF:IllegalArgumentException: "+implClassName+": "+e);
       e.printStackTrace();
    }
    catch(NoSuchMethodException e){
      System.out.println("MF:NoSuchMethodException :"+implClassName+": "+e);
       e.printStackTrace();
    }

    //added
    BeanContextChildSupport bcs = (BeanContextChildSupport)implObj;
    bcs.setObjectID(objectID);
    System.out.println("After get BeanContextChildSupport Invoke");
    //added

    //connect it to object adapter
    orb.connect(tieObj);
   
    //return the created product,one actor
    return tieObj;
  }
   
   
 


}


